#/bin/sh
#
# AzBox HD Backup v0.94 for OpenXCAS
# (c) by monkus (mooncusz@gmail.com)
#
# description
# utility to backup and restore all important azbox hd settings. sure, i have only
# restricted configuration, just report your settings (configuration files) and bugs
# to my email. this plugin is usefully in case of firmware upgrading with format 
# application area f.e.
# 
# 0.9
# - new code :-)
# - channel list
# - browser and rss settings
# - users and password
# - plugins and addons lists
# - some system settings
# - samba configuration, users and passwords
# - ssh keys and configuration
# - main backup list (/PLUGINS/OpenXCAS/backup/backup.list)
# - custom list of files and directories (/PLUGINS/OpenXCAS/backup/custom.list)
# - EMU directory
# - restore script after factory reset
# 0.91
# - DVB-C and DVB-T support
# 0.92
# - prevent plugin starting after reboot
# - active red led during backup
# 0.93
# - writing all buffered filesystem blocks to disk before reboot
# - some warnings in restore.sh script
# - possible to choose archive to restore (./restore.sh /path/to/archive.tar)
# - compatibility with azbox webinterface (by DEDEX7200Pro. Original from joseba and koivo)
# 0.94
# - added iptv channels backup
# - added plugin description
# - fixed directory structure change EMU -> PLUGINS (0.9.3378 and higher)
# - if backup from old directory sctructure will be restoted to new one,
#   just run command "ln -s /PLUGINS /EMU" before running restore.sh script

TIMESTAMP=`date +%Y%m%d%H%M%S`
BACKUPLIST=/MMP/httpd/configs/backup.list
CUSTOMLIST=/MMP/httpd/configs/custom.list
read BACKUPDIR </MMP/httpd/configs/path.list

AWK=/usr/bin/awk
CAT=/bin/cat
CP=/bin/cp
EGREP=/bin/egrep
FIND=/usr/bin/find
GREP=/bin/grep
CHMOD=/bin/chmod
LED="/MMP/usr/bin/vfd_display -td210 -led"
LN=/bin/ln
MKDIR=/bin/mkdir
MOUNT=/bin/mount
RM=/bin/rm
SED=/bin/sed
TAR=/bin/tar
TEST=/usr/bin/test

check_dir () {
  $TEST -d $BACKUPDIR
  if [ "$?" = 1 ]; then
    $MKDIR $BACKUPDIR
  fi
}   

check_list () {                                                                                                                                                      
  for i in `$CAT $BACKUPLIST $CUSTOMLIST$GREP -v "#"`; do
    if [ -e $i ]; then
      LIST="$LIST $i"
    fi  
  done   
}  

backup_list () {
  echo 
  echo Backup List: 
  $LED ron 
  $TAR cvf $BACKUPDIR/$TIMESTAMP.tar $LIST
  $LED roff
  echo 
}

post_backup () {
  if [ -e $BACKUPDIR/latest.tar ]; then  
    $RM $BACKUPDIR/latest.tar
  fi  
  $CP $BACKUPDIR/$TIMESTAMP.tar $BACKUPDIR/latest.tar
  echo "Latest Backup Archive: $BACKUPDIR/$TIMESTAMP.tar" 
}  

disable_plugin () {
  $GREP backup /PLUGINS/OpenXCAS/module.seq$GREP "#" >> /dev/null
    if [ $? != 0 ]; then
      $SED -i 's/backup/\#backup/' /PLUGINS/OpenXCAS/module.seq
    fi 
}
                
      
echo "AzBox HD Backup v0.94 for OpenXCAS (c) by monkus"   

check_dir
check_list
backup_list
post_backup
#disable_plugin
