#/bin/sh
#
# AzBox HD Backup v0.91 for OpenXCAS
# (c) by monkus (mooncusz@gmail.com)

# 0.9
# - new code :-)
# - channel list
# - browser and rss settings
# - users and password
# - plugins and addons lists
# - some system settings
# - samba configuration, users and passwords
# - ssh keys and configuration
# - main backup list (/EMU/OpenXCAS/backup/backup.list)
# - custom list of files and directories (/EMU/OpenXCAS/backup/custom.list)
# - EMU directory
# - restore script after factory reset
# 0.91
# - DVB-C and DVB-T support
# 0.92
# - prevent plugin starting after reboot
# - active red led during backup

TIMESTAMP=`date +%Y%m%d%H%M%S`
BACKUPLIST=/MMP/httpd/configs/backupwi.list
read BACKUPDIR </MMP/httpd/configs/path.list

AWK=/usr/bin/awk
CAT=/bin/cat
CP=/bin/cp
EGREP=/bin/egrep
FIND=/usr/bin/find
GREP=/bin/grep
CHMOD=/bin/chmod
LED="/MMP/usr/bin/vfd_display -td210 -led"
LN=/bin/ln
MKDIR=/bin/mkdir
MOUNT=/bin/mount
RM=/bin/rm
SED=/bin/sed
TAR=/bin/tar
TEST=/usr/bin/test
WI=wi_backup_
WIDIR=wi

check_dir () {
  $TEST -d $BACKUPDIR/$WIDIR
  if [ "$?" = 1 ]; then
    $MKDIR $BACKUPDIR
	$MKDIR $BACKUPDIR$WIDIR
  fi
}   

check_list () {                                                                                                                                                      
  for i in `$CAT $BACKUPLIST$GREP -v "#"`; do
    if [ -e $i ]; then
      LIST="$LIST $i"
    fi  
  done   
}  

backup_list () {
  echo 
  echo Backup List: 
  $LED ron 
  $TAR cvf $BACKUPDIR/$WIDIR/$WI$TIMESTAMP.tar $LIST
  gzip $BACKUPDIR/$WIDIR/$WI$TIMESTAMP.tar
  $LED roff
  echo 
}

post_backup () {
  if [ -e $BACKUPDIR/$WIDIR/$WI$TIMESTAMP.tar ]; then  
    $RM $BACKUPDIR/$WIDIR/$WI$TIMESTAMP.tar
  fi  
  echo "Latest Backup Archive: $BACKUPDIR/$WIDIR/$TIMESTAMP.tar" 
}  
              
      
echo "AzBox HD Webinterface Backup v0.92"
echo "(c) by monkus"    

check_dir
check_list
backup_list
post_backup
