#/bin/sh
#
# AzBox HD USB Background Copy Script v1.5 for OpenXCAS
# (c) by monkus (mooncusz@gmail.com)
#
# if you want to copy data f.e. from usb stick to internal or external disk without using your computer, you
# can run copying from this plugin with remote controller. during this operation, it is possible to watch
# tv, browsing or go to standby. it is recommended to use swapon plugin (part of monkus openxcas tools)
# before using usb background copy script. don't forget to setup variables SOURCEDIR, TARGETDIR and TARGETDISK.
# 
# 1.1 
# - need to have data on usb device in directory "123456"
# - all mounted usb devices will be scanned for this directory
# - data (files, directories) will be copied to $TARGET
# - default $TARGET is internal disk (az hd premium), directory "download"
# - start copying from plugin / openxcas / usbcopy or by remote controler
# - data is copying on background, possible to watch tv or browsing f.e.
# - or switch azbox to standby mode
# - red led active during copying
# - check blinking red led on azbox for finnished job
# - stupid prevent from duplicate copying
# 1.2
# - new code :-)
# - prevent plugin starting after reboot
# - fixed small bug with red led
# 1.3
# - check, if usb device exists
# - compatibility with azbox webinterface (by DEDEX7200Pro. Original from joseba and koivo)
# 1.4
# - fixed bug during copying data from usb2 to usb1 device
# 1.5
# - fixed directory structure change EMU -> PLUGINS (0.9.3378 and higher)
# - added plugin description

# best practice $SOURCEDIR is 123456 (all fs compatibility - fat supports only 8 characters, not case sensitive)
# create directory, move files within one usb device is quick also with OSD :-) 
#SOURCEDIR=123456
read SOURCEDIR </MMP/httpd/configs/source.list

# default is internal disk, change it to your external disk mount point if needed 
#TARGETDISK=/DATA/hdb1
read TARGETDISK </MMP/httpd/configs/target.list
#TARGETDISK=/DATA/usb1/sda1

# default directory on $TARGETDISK is download
read TARGETDIR </MMP/httpd/configs/targetdir.list
#TARGETDIR=download
TARGET=$TARGETDISK/$TARGETDIR

AWK=/usr/bin/awk
CAT=/bin/cat
CP=/bin/cp
GREP=/bin/grep
LED="/MMP/usr/bin/vfd_display -td210 -led"
MKDIR=/bin/mkdir
MOUNT=/bin/mount
PS=/bin/ps
SED=/bin/sed
TEST=/usr/bin/test
UPTIME=/usr/bin/uptime
WEBIF=$1

web_variables () {                                                                                                                                                   
 if [ "$WEBIF" = "webif" ]
   then
     echo Using variables from web interface
     read SOURCEDIR </MMP/httpd/configs/source.list
     read TARGETDISK </MMP/httpd/configs/target.list
     read TARGETDIR </MMP/httpd/configs/targetdir.list
 fi
}  

disable_plugin () {
  $GREP usbcopy /PLUGINS/OpenXCAS/module.seq$GREP "#" >> /dev/null
    if [ $? != 0 ]; then
      $SED -i 's/usbcopy/\#usbcopy/' /PLUGINS/OpenXCAS/module.seq
    fi 
}

check_device () {                                                              
  $MOUNT$GREP $TARGETDISK >> /dev/null
  if [ "$?" = 1 ]; then                                                       
    echo "Target device doesn't exist" 
    disable_plugin                                                            
    exit 1                                                                    
  fi                                                                          
  $MOUNT$GREP sd[a-x][1-9] >> /dev/null
  if [ "$?" = 1 ]; then                                                                                                                                              
    echo "Source device doesn't exist"                                                                                                                               
    disable_plugin                                                                                                                                                   
    exit 1                                                                                                                                                           
  fi         
}  
                          
check_usb () {
  for i in `$MOUNT$GREP sd[a-x][1-9]$AWK '{ print $3 }'`; do 
    $TEST -x $i/$SOURCEDIR
    if [ "$?" = 1 ]; 
      then
        echo No data to copy from $i/$SOURCEDIR
        disable_plugin 
#        exit 1 
      else
        check_duplicate                                                                                                                                                       
        data_copy                                                                                                                                                             
        disable_plugin            
    fi 
  done 
}

check_duplicate () {
  $PS -aefgrep "$CP -r $i/$SOURCEDIR/"$GREP -v grep 
  if [ "$?" = 0 ]; then 
    echo 
    echo Copying in progress, exiting ... 
    disable_plugin
    exit 1 
  fi
}                                    

data_copy () {
  echo Copying data from $i/$SOURCEDIR to $TARGET  
  $LED ron
  $CP -r $i/$SOURCEDIR/* $TARGET/
  COUNTER=10
  until [ $COUNTER -lt 0 ]; do
    let COUNTER-=1
    $LED ron
    sleep 1
    $LED roff 
    sleep 1 
  done
}

echo "AzBox HD USB Background Copy Script v1.5 for OpenXCAS (c) by monkus"

web_variables
check_device
check_usb
