#/bin/sh
#
# AzBox HD USB Mount Script v2.3 for OpenXCAS
# (c) by monkus (mooncusz@gmail.com)
#
# description:
# some types of usb sticks (f.e. my sandisk cruzer) have problems with azbox automount script. 
# this plugin will probe usb device before running default usb_script.sh. with this plugin, 
# you can mount usb devices using remote controller, no need to connect to you computer via
# telnet/ssh and do that manually. remote controller contains button "usb" for unmountig, but
# missing button for usb mounting. 
# 
# 2.0 
# - new code (using stb default usb mount tool)
# - front and rear usb port support
# - default stb fs support (ext3, ext2, fat32 and read-only ntfs)
# - solved problem with some usb devices formated by windows
# - usb devices must have correct partition table
# 2.1
# - prevent plugin starting after reboot
# 2.2
# - small probe hack to mount some usb devices with isofs (secondary root)
# - compatibility with azbox webinterface (by DEDEX7200Pro. Original from joseba and koivo)
# 2.3
# - fixed directory structure change EMU -> PLUGINS (0.9.3378 and higher)
# - added plugin description 

FDISK=/sbin/fdisk
GREP=/bin/grep
SED=/bin/sed
SLEEP=/bin/sleep

probe_devices () {
  for i in `ls /dev/sd[a-x]`; do 
    $FDISK -l $i > /dev/null
  done
}

usb_mount () {
  echo
  export ACTION=init
  $SLEEP 2 
  /MMP/usr/bin/usb_script.sh
}

disable_plugin () {
  $GREP usbmount /PLUGINS/OpenXCAS/module.seq$GREP "#" >> /dev/null
  if [ $? != 0 ]; then
    $SED -i 's/usbmount/\#usbmount/' /PLUGINS/OpenXCAS/module.seq
  fi 
}

echo "AzBox HD USB Mount Script v2.3 for OpenXCAS (c) by monkus" 

probe_devices
usb_mount
disable_plugin
